﻿
@{
    ViewBag.Title = "Redirect";
    Layout = null;
}

<h2>Redirecting...</h2>

<form style="display: none" action="~/IAMLogin/RedirectSuccess" method="POST" id="Redirect">
    <input type="hidden" id="id_token" name="id_token" value="" />
    <input type="hidden" id="raw_token" name="raw_token" value="" />
</form>
<script src="~/Scripts/jquery-3.3.1.min.js"></script>
<script>

    var keyStr = "ABCDEFGHIJKLMNOP" +
        "QRSTUVWXYZabcdef" +
        "ghijklmnopqrstuv" +
        "wxyz0123456789+/" +
        "=";

    var callbackResponse = (document.URL).split("#")[1];
    var responseParameters = (callbackResponse).split("&");
    var parameterMap = [];
    for (var i = 0; i < responseParameters.length; i++) {
        parameterMap[responseParameters[i].split("=")[0]] = responseParameters[i].split("=")[1];
    }
    if (parameterMap.access_token !== undefined && parameterMap.access_token !== null) {
        if (parameterMap.id_token !== undefined && parameterMap.id_token !== null) {
            var m = parameterMap.id_token.indexOf(".");
            var n = parameterMap.id_token.lastIndexOf(".");

            var jwt_body = parameterMap.id_token.substring(m + 1, n);
            console.log("========START=========");
            console.log(jwt_body);
            console.log("========END=========");

            $("#id_token").val(btoa(decode64(jwt_body)));
            $("#raw_token").val(parameterMap.id_token);
            $("#Redirect").submit();

            console.log(decode64(jwt_body));
        }
    }
    function decode64(input) {
        var output = "";
        var chr1, chr2, chr3 = "";
        var enc1, enc2, enc3, enc4 = "";
        var i = 0;

        // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
        var base64test = /[^A-Za-z0-9\+\/\=]/g;
        if (base64test.exec(input)) {
            alert("There were invalid base64 characters in the input text.\n" +
                "Valid base64 characters are A-Z, a-z, 0-9, '+', '/',and '='\n" +
                "Expect errors in decoding.");
        }
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        do {
            enc1 = keyStr.indexOf(input.charAt(i++));
            enc2 = keyStr.indexOf(input.charAt(i++));
            enc3 = keyStr.indexOf(input.charAt(i++));
            enc4 = keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

            chr1 = chr2 = chr3 = "";
            enc1 = enc2 = enc3 = enc4 = "";

        } while (i < input.length);

        return unescape(output);
    }
</script>
